/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: UpdateMethod.java 4389 2008-12-15 13:48:57Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.pool.impl.enhanced.impl.listener.resizer;

/**
 *
 * @author Gael Lalire
 */
public enum UpdateMethod {

    NEVER, BEFORE, AFTER_SUCCESSFUL, BEFORE_AFTER_SUCCESSFUL,
    AFTER_FAILED, BEFORE_AFTER_FAILED, AFTER, ALWAYS;

    public boolean isBefore() {
        boolean before = false;
        switch (this) {
        case BEFORE:
        case BEFORE_AFTER_FAILED:
        case BEFORE_AFTER_SUCCESSFUL:
        case ALWAYS:
            before = true;
        default:
            break;
        }
        return before;
    }

    public boolean isAfterSuccessful() {
        boolean afterSuccessful = false;
        switch (this) {
        case AFTER:
        case AFTER_SUCCESSFUL:
        case BEFORE_AFTER_SUCCESSFUL:
        case ALWAYS:
            afterSuccessful = true;
        default:
            break;
        }
        return afterSuccessful;
    }

    public boolean isAfterFailed() {
        boolean afterFailed = false;
        switch (this) {
        case AFTER:
        case AFTER_FAILED:
        case BEFORE_AFTER_FAILED:
        case ALWAYS:
            afterFailed = true;
        default:
            break;
        }
        return afterFailed;
    }


}
